#include<stdio.h>
#include<stdlib.h>
#include<stdint.h>
#include<string.h>
#include<mqueue.h>
#include<unistd.h>
#include<sys/msg.h>
#include<signal.h>

#define BUFF_SIZE 256

typedef struct{
    long type;
    int msgnum;
    char msg_buff[BUFF_SIZE];
} mq_attr;

int msqid;
 
void sig_handler()
{
  printf("\n\ngot the SIGINT signal, parent process will die");
  msgctl(msqid, IPC_RMID, NULL);
  kill(SIGINT, 0);
  printf("\nchild process will die, too\n");
  exit(1);
}

void server_function()
{
    mq_attr attr;
    char result[20];
    signal(SIGINT, sig_handler);
    
 
    msqid = msgget((key_t)0123, IPC_CREAT|0666);

    if(msqid == -1)
    {
        perror("parent mq open fail");
        exit(0);
    }
    else
        printf("parent's queue has opened!\n");

    while(1) {
        if(msgrcv(msqid, &attr, sizeof(struct mq_attr),2,0) == -1)
        {
            perror("couldn't get the messages well\n");
            exit(-1);
        }
        printf("read data from the queue: %s\n", attr.msg_buff);
    }
    
}

void client_function()
{
    mq_attr attr;
    char buf[20];
    int msqid;
  

    if(-1 == (msqid = msgget((key_t)0123, IPC_CREAT|0666)))
    {
        perror("child mq open fail");
        exit(1);
    }
    else
        printf("child's message queue has opened!\n");
    while(1){
        printf("\nType of the data?: ");
        scanf("%ld", &attr.type);
        printf("Input Data into the queue: ");
        scanf("%s", attr.msg_buff);
        
        if(msgsnd(msqid, &attr, sizeof(struct mq_attr), IPC_NOWAIT) == -1)
        {
            perror("message haven't sent to the queue successfully");
            exit(1);
        }
      sleep(1);    
    }
}


int main(int argc, char** argv)
{
    int pid = fork();
    int death;

    if(pid > 0)
    {
        printf("Parents Process: %d, %d\n", getpid(), pid);
        server_function();
    }
    else if(pid == 0)
    {
        printf("\nChild Process: %d, %d\n", getpid(), pid);
        client_function();
    }
    else if(pid == -1)
    {
        perror("fork error : ");
        exit(0);
    }

    return 0;
}
